/*-------------------------------------------------------------------------
 * rtppostevent.c - rtppostevent
 *-------------------------------------------------------------------------
 */

#include <rtp.h>
#include <event.h>

/*------------------------------------------------------------------------
 * rtppostevent - post an event to each registered event queue in the 
 * session
 *------------------------------------------------------------------------
 */
int
rtppostevent(struct session *psn, int type, ssrc_t ssrc, void *data, int length)
{

	int i;
	int rv = OK;

	pthread_mutex_lock(&psn->sn_mutex);
	for (i = 0; i < RTP_MAXEVENTQUEUES; i++)
		if (psn->sn_eventqs[i] != NULL)
			if ((eventqpost(psn->sn_eventqs[i], type, ssrc, data, length)) == ERROR) 
				rv = ERROR;
	pthread_mutex_unlock(&psn->sn_mutex);
	return rv;
}
