/*-------------------------------------------------------------------------
 * synstreamdestroy.c - synstreamdestroy
 *-------------------------------------------------------------------------
 */

#include <syn.h>
#include <stdlib.h>

/*------------------------------------------------------------------------
 * synstreamdestroy - deallocate resources used by a synstream state block
 * Synstreamdestroy is meant to be called by hashtable routines.
 *------------------------------------------------------------------------
 */
void
synstreamdestroy(struct synstream *psstm)
{
	pthread_mutex_destroy(&psstm->sstm_readmutex);
	pthread_cond_destroy(&psstm->sstm_readcond);
	free(psstm->sstm_parameters);
	free(psstm);
}
